#!/usr/bin/env ruby

class CSVParser < Array
  def initialize(filename)
	File.open(filename) do |ifile|
	  ifile.each do |line|
		line.sub!(/\#.*/, '')
		if (line =~ /^\s+$/) then
		  next
		end

		rows = Array.new
		splited = line.split(/,/)
		i = 0
		while (i < splited.length)
		  row = splited[i]
		  if (row =~ /^"/) then
			row.sub!(/^"/, '')
			while (row !~ /"$/)
			  i += 1
			  if (i >= splited.length) then
				i = 0
				line = ifile.gets
				splited = line.split(/,/)
			  end
			  row += splited[i]
			  row.gsub!(/""/, '"')
			end
			row.sub!(/"$/, '')
		  end

		  rows.push(row)
		  i += 1
		end

		push(rows)
	  end
	end
  end
end

